
Core - Bug # 52828

Status: Resolved Priority: Must have
Author: Philipp Gampe Category:
Created: 2013-10-15 Assigned To:
Updated: 2013-12-02 Due date:
TYPO3 Version: 6.2
PHP Version: 5.5
Complexity: hard
Is Regression: No
Sprint Focus:
Subject: extTables cache file creation does not respect extension order
Description

All extTables.php are included in the alphabetical order off the extension keys.

They must be ordered by dependencies.

Related issues:
related to Core - Bug # 52984: PackageManager resolving dependencies uses fol... Rejected 2013-10-20
related to Core - Bug # 53178: Package loading order does not respect Extensi... Closed 2013-10-28
related to TYPO3.Flow - Feature # 54151: Implement proper package dependency ... Resolved 2013-12-02

Associated revisions
Revision a71add78 - 2013-10-20 20:32 - Markus Klein

[BUGFIX] Sorting of packages by dependency

Implement proper dependency handling in Flow PackageManager.
The code ensures that all framework packages are loaded first.

Releases: 6.2
Resolves: #52828
Change-Id: I6717756efae28b1f8e13fc3a251328f69f54b4d4
Reviewed-on: https://review.typo3.org/24852
Reviewed-by: Helmut Hummel
Tested-by: Helmut Hummel
Tested-by: Anja Leichsenring
Reviewed-by: Stefan Neufeind
Reviewed-by: Jigal van Hemert
Tested-by: Jigal van Hemert

History
#1 - 2013-10-16 18:19 - Helmut Hummel
- Status changed from New to Accepted
- Target version set to 6.2.0

I identified two issues:

    1. The dependencies of system extensions are not set correctly (e.g. openid extension should depend on setup as it adds a user setup field). Along
side with this, TER Extensions need to be more specific what their dependencies are to be ordered correctly
    2. PackageManager::sortAvailablePackagesByDependencies() does not work correctly. Packages are not correctly ordered by dependency in
certain cases (needs more checks to find the issues there)

#2 - 2013-10-16 18:19 - Helmut Hummel
- Complexity changed from easy to hard

#3 - 2013-10-17 01:54 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#4 - 2013-10-17 02:04 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#5 - 2013-10-17 02:05 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#6 - 2013-10-17 02:14 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#7 - 2013-10-17 02:14 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#8 - 2013-10-17 12:26 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#9 - 2013-10-17 12:34 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#10 - 2013-10-17 15:40 - Gerrit Code Review
Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#11 - 2013-10-17 23:56 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#12 - 2013-10-18 19:22 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#13 - 2013-10-18 19:40 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#14 - 2013-10-20 14:31 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#15 - 2013-10-20 15:53 - Gerrit Code Review

Patch set 14 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#16 - 2013-10-20 16:15 - Gerrit Code Review

Patch set 15 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#17 - 2013-10-20 16:29 - Gerrit Code Review

Patch set 16 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#18 - 2013-10-20 19:36 - Gerrit Code Review

Patch set 17 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24852

#19 - 2013-10-20 21:30 - Markus Klein
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:a71add783d882f91fa169c971992eacdcf5dbcb0.

#20 - 2013-12-02 21:03 - Markus Klein

For documentation, these two concepts were used in the patch:

    -  http://en.wikipedia.org/wiki/Dependency_graph
    -  http://en.wikipedia.org/wiki/Topological_sorting (Algo by Kahn (1962))
